/*
   $Header: /u/spert/src/fltvec/testsuite/RCS/scalar_test.c,v 1.2 1996/04/10 23:29:50 davidj Exp $

   Test scalar routines
*/

#include <stddef.h>
#include <stdlib.h>

#include "fltvec_test.h"

void
test_isnan_f_b(void)
{
    rtst_start("nv_isnan_f_b");
    rtst_assert(nv_isnan_f_b(0.0f)==FLTV_FALSE);
    rtst_assert(nv_isnan_f_b(-1234.5f)==FLTV_FALSE);
    rtst_assert(nv_isnan_f_b(1.0f/0.0f)==FLTV_FALSE);
    rtst_assert(nv_isnan_f_b(-1.0f/0.0f)==FLTV_FALSE);
    rtst_assert(nv_isnan_f_b(0.0f/0.0f)==FLTV_TRUE);
    rtst_passed();
#ifdef CHECK_NFP
    rtst_start("nfp_isnan_f_b");
    rtst_assert(nfp_isnan_f_b(0.0f)==FLTV_FALSE);
    rtst_assert(nfp_isnan_f_b(-1234.5f)==FLTV_FALSE);
    rtst_assert(nfp_isnan_f_b(1.0f/0.0f)==FLTV_FALSE);
    rtst_assert(nfp_isnan_f_b(-1.0f/0.0f)==FLTV_FALSE);
    rtst_assert(nfp_isnan_f_b(0.0f/0.0f)==FLTV_TRUE);
    rtst_passed();
#endif
}

void
test_isnan_d_b(void)
{
    rtst_start("nv_isnan_d_b");
    rtst_assert(nv_isnan_d_b(0.0)==FLTV_FALSE);
    rtst_assert(nv_isnan_d_b(-1234.5)==FLTV_FALSE);
    rtst_assert(nv_isnan_d_b(1.0/0.0)==FLTV_FALSE);
    rtst_assert(nv_isnan_d_b(-1.0/0.0)==FLTV_FALSE);
    rtst_assert(nv_isnan_d_b(0.0/0.0)==FLTV_TRUE);
    rtst_passed();
#ifdef CHECK_NFP
    rtst_start("nfp_isnan_d_b");
    rtst_assert(nfp_isnan_d_b(0.0)==FLTV_FALSE);
    rtst_assert(nfp_isnan_d_b(-1234.5)==FLTV_FALSE);
    rtst_assert(nfp_isnan_d_b(1.0/0.0)==FLTV_FALSE);
    rtst_assert(nfp_isnan_d_b(-1.0/0.0)==FLTV_FALSE);
    rtst_assert(nfp_isnan_d_b(0.0/0.0)==FLTV_TRUE);
#endif
    rtst_passed();
}


int
main(int argc, char *argv[])
{
    rtst_args(argc, argv);

    test_isnan_f_b();
    test_isnan_d_b();

    rtst_exit();

    return 0;
}
