/*
** $Header: /u/spert/src/fltvec/tor/RCS/milli_vfvf_vf.S,v 1.2 1995/10/13 03:29:57 davidj Exp $
**
** Routines that use millicode to do op_vfvf_vf
*/

#include "tor/tordef.h"
#include "m_regdef.h"

#define length a0
#define aPtr a1
#define bPtr a2
#define zPtr a3
#define savedRA t0
#define autoincrement t1
#define done t2
#define maxvlr t3


#define MILLI_VFVF_VF(RTNNAME, MILLINAME) \
	.globl RTNNAME; \
	.ent RTNNAME; \
RTNNAME: \
        .set    noreorder; \
        bgtu    length, MAXVLEN, 1f; \
        ctvu    length, vlr; \
        .set    reorder; \
	lw.v va0,aPtr; \
	move savedRA, ra; \
	lw.v va1, bPtr; \
	jal MILLINAME; \
	sw.v vz0,zPtr; \
	j savedRA; \
\
1: \
	li maxvlr,MAXVLEN; \
	ctvu maxvlr,vlr; \
	li autoincrement,(4*MAXVLEN); \
	lwai.v va0,aPtr,autoincrement; \
	move savedRA, ra; \
	lwai.v va1,bPtr,autoincrement; \
2: \
	jal MILLINAME; \
	lwai.v va0,aPtr,autoincrement; \
	subu length, MAXVLEN; \
        sltu done, length, MAXVLEN+1; \
	lwai.v va1, bPtr, autoincrement; \
	swai.v vz0,zPtr, autoincrement; \
	beqz done, 2b; \
\
	ctvu length,vlr; \
	jal MILLINAME; \
	sw.v vz0,zPtr; \
	j savedRA; \
	.end RTNNAME

/****************************************************************/ 

#ifdef DECL_tor_add_vfvf_vf
void tor_add_vfvf_vf(size_t len, const float* a, const float* b, float* res);
#endif

#ifdef DEFN_tor_add_vfvf_vf
MILLI_VFVF_VF(tor_add_vfvf_vf, tor_add_gfgf_gf)
#endif

/****************************************************************/

#ifdef DECL_tor_sub_vfvf_vf
void tor_sub_vfvf_vf(size_t len, const float* a, const float* b, float* res);
#endif

#ifdef DEFN_tor_sub_vfvf_vf
MILLI_VFVF_VF(tor_sub_vfvf_vf, tor_sub_gfgf_gf)
#endif


/****************************************************************/

#ifdef DECL_tor_mul_vfvf_vf
void tor_mul_vfvf_vf(size_t len, const float* a, const float* b, float* res);
#endif

#ifdef DEFN_tor_mul_vfvf_vf
MILLI_VFVF_VF(tor_mul_vfvf_vf, tor_mul_gfgf_gf)
#endif


/****************************************************************/

#ifdef DECL_tor_div_vfvf_vf
void tor_div_vfvf_vf(size_t len, const float* a, const float* b, float* res);
#endif

#ifdef DEFN_tor_div_vfvf_vf
MILLI_VFVF_VF(tor_div_vfvf_vf, tor_div_gfgf_gf)
#endif


